/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#ifndef FILTRATOR_FILTRATOR_H
#define FILTRATOR_FILTRATOR_H
#include "matrices_all.h"
#include "options.h"

namespace filtrator
{
	class Filtrator
	{
		public:
			Filtrator(const Params &p);
			void Start();
		private:
			void LoadWords();
			void FilterColumns();
			void FilterRows();

			void WriteMatrixColumnBased();
			void PrepareFeaturesColumnBased(Matrices::CRSMatrixPtr pCRS);

			std::set<std::string> m_setWords;
			Params m_Params;

			size_t m_stUnitCount;
			std::string m_sCorpusInfo;
			Matrices::FeatureVectorPtr m_pvRowFeatures;
			Matrices::FeatureVectorPtr m_pvColumnFeatures;
			std::vector<Matrices::CompressedVectorPtr> m_vColumns;

	};
}//namespace filtrator

#endif //FILTRATOR_FILTRATOR_H

